#!/usr/bin/perl
#
# usage: ./mkdep <source>
#

# GLOBAL defines

use Getopt::Std;
getopts("vhs1");

if ($opt_h) {
  die "syntax: mkdep.pl [-h] [-v] [-s] [infile(s)] [ >outfile ] \n\n" 
     ."        recursively scans all '#include' lines for dependencies.\n"
     ."        -v   verbose \n"
     ."        -s   sort results \n"
     ."        -1   output all headers in a single line\n"
     ."        -h   you never guess what this does ;-) \n"
     ."\n";
};

@ipath = ('', '../include/');

# first: process command line files

#  use m'[#]include[ \t]*[<"]([/\w\.]*)[>"]'o 
#  instead of m'[#]include[ \t]*["]([/\w\.]*)["]'o
#  if you want lines like #include <cstdio> processed

while (<>) {
  if ( m'[#]include[ \t]*["]([/\w\.]*)["]'o ) {
    foreach $p (@ipath) {
      $incfilesdone{$p . $1} = 0 ;
      push( @todo, $p . $1 ) ;
    };
  };
};

# 2nd: the same for all files found 
while (@todo) {
  if ($incfilesdone{$todo[0]} == 0) {
    $todo[0] =~ m'([/\w\.]*/)?([\w\.]*)'o;
    $path = $1;
    $file = $2;
    if (open (FILE, "< $path$file")) { 
      print "processing file $path$file \n" if ($opt_v);
      while (<FILE>) {
        if ( m'[#]include[ \t]*["]([/\w\.]*)["]'o ) {
          do { 
	    foreach $p (@ipath) {
	      push( @todo, ($p . $path . $1) );
	      $incfilesdone{($p . $path . $1)} = 0; 
	      push( @todo, ($p . $1) );
	      $incfilesdone{($p . $1)} = 0; 
	    };
	  } unless $incfilesdone{($path . $1)} != 0;
        };
      };
      $incfilesdone{$todo[0]} = 1;
    } else {
#      print "skipping file $path$file \n" if ($opt_v);
    };
  };
  shift @todo;
};

foreach $k ($opt_s?sort(keys(%incfilesdone)):keys(%incfilesdone)) {
  if ($incfilesdone{$k} == 1) {
    print $k;
    if ($opt_1) {print " ";} else {print "\n";};
  } else {
#    print "not found: ", $k, $incfilesdone{$k}, "\n" if ($opt_v);
  }
}

print "\n",'done. ',"\n" if ($opt_v);
